#!/bin/sh

#
# Set JAVA_HOME and J2EE_HOME before running this script.
#
# set JAVA_HOME to the path where you have Java 2 installed.
#
# set J2EE_HOME to the path where you have installed this package (EJB server).
#

if [ -z $JAVA_HOME ]
then
    echo "Please, set JAVA_HOME before running this script."
    exit;
fi

if [ -z $J2EE_HOME ]
then
    echo "Please, set J2EE_HOME before running this script."
    exit;
fi

if [ ! -f bin/start.sh ]
then
    echo "Please start this script from the SyncServer home directory."
    exit;
fi

#
# Other settings
#
SYNC4J_HOME=$PWD
JAVA_OPTS="-Djava.util.logging.config.file=$SYNC4J_HOME/lib/logging/common/logging.properties -Dsync4j.dm.home=$SYNC4J_HOME"
#
# Uncomment the following line to enable remote debugging
#
#JAVA_OPTS="-classic -Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=8787,server=y,suspend=n $JAVA_OPTS"

export JAVA_OPTS;

#
# Run JBoss
#
cd $J2EE_HOME/bin

./run.sh -c sync4j

