<%--
 Copyright (C) 2003-2005 Funambol
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --%>

<%-- author: Stefano Nichele @ Funambol --%>
<%-- $Id: getDeviceDetailsSession.jsp,v 1.1 2005/05/16 17:00:37 nichele Exp $ --%>

<%@ taglib prefix="sql" uri="/WEB-INF/tlds/sql.tld" %>
<%@ taglib prefix="c" uri="/WEB-INF/tlds/c.tld" %>
<%@ taglib prefix="fmt" uri="/WEB-INF/tlds/fmt.tld" %>

<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.beans.*" %>

<%@ page import="org.apache.taglibs.standard.tag.common.sql.ResultImpl" %>

<%@ page import="sync4j.framework.engine.dm.*" %>
<%@ page import="sync4j.framework.core.*" %>

<%@ page errorPage = "ErrorPage.jsp" %>

<fmt:setLocale value="en_EN" />
<fmt:setBundle basename="DMDemo" />

<jsp:useBean id="dmDemoBean" scope="session" class="sync4j.dmdemo.DMDemoBean"/>

<%
    // Set the datasource in session
    session.setAttribute("dataSource", dmDemoBean.getDataSource());

    String newSession  = request.getParameter("newSession");

    String deviceId    = request.getParameter("deviceId");
    String sessionId   = request.getParameter("sessionId");

    String save        = request.getParameter("save");

    String refresh = request.getParameter("refresh");

    if (deviceId != null) {
        dmDemoBean.setDeviceId(deviceId);
    } else {
        deviceId = dmDemoBean.getDeviceId();
    }

    if (newSession != null && newSession.equalsIgnoreCase("true")) {
        dmDemoBean.startNewManagementSession(deviceId, sync4j.dmdemo.DMDemoBean.PROCESSOR_GET_DEVICE_DETAILS);
        deviceId  = dmDemoBean.getDeviceId();
        dmDemoBean.saveSession();

        %>
            <jsp:forward page="main.jsp" />
        <%

    }

    if (save != null && save.equalsIgnoreCase("true")) {
        dmDemoBean.saveSession();
    }

    if (refresh != null && refresh.equalsIgnoreCase("true")) {
        if (sessionId != null && !sessionId.equals("")) {
            dmDemoBean.setSessionId(sessionId);
        } else {
            sessionId = dmDemoBean.getSessionId();
        }
        dmDemoBean.loadSession(sessionId);
    }

    sessionId = dmDemoBean.getSessionId();

    String stateDescription = dmDemoBean.getStateDescription();

%>

<c:set var="state"><%= dmDemoBean.getSessionState() %></c:set>

<html>
<head>
<title><fmt:message key="WINDOW_TITLE" /></title>
<link rel="stylesheet" type="text/css" href="../css/style.css" />
</head>

<script language="JavaScript1.2">

    function refreshList() {
        location.href = 'getDeviceDetailsSession.jsp?deviceId=<%= deviceId%>&refresh=true';
    }


    function goBack() {
        //showProp(document.documentElement, 'document.documentElement');
        document.location.href = 'main.jsp';
    }
</script>
</head>

<body>
    <form name="operations" method="get" action="getDeviceDetailsSession.jsp">
        <input type="hidden" name="addOp" value="true" />
        <input type="hidden" name="deviceId" value="<%=deviceId%>" />
        <input type="hidden" name="sessionId" value="<%= sessionId%>" />
        <input type="hidden" name="state" value='<c:out value="${state}"/>' />

    <table width="100%" border="0" bordercolor="blue">
        <tr>
            <td align="center">
                <table cellpadding="2" cellspacing="0">
                    <tr>
                        <td><fmt:message key="DEVICE_ID" />:</td>
                        <td><%= deviceId%></td>
                    </tr>
                     <tr>
                        <td><fmt:message key="SESSION_ID" />:</td><td><%= sessionId%></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="STATE" />:</td>
                        <td>
                            <c:if test="${state == 'P'}">
                                <fmt:message key="STATE_TO_PROCESS" />
                            </c:if>
                            <c:if test="${state == 'C'}">
                                <fmt:message key="STATE_COMPLETED" />
                            </c:if>
                            <c:if test="${state == 'N'}">
                                <fmt:message key="STATE_NOTIFIED" />
                            </c:if>
                            <c:if test="${state == 'E'}">
                                <fmt:message key="ERROR" />
                            </c:if>
                            <c:if test="${state == 'A'}">
                                <fmt:message key="ABORTED" />
                            </c:if>
                        </td>
                    </tr>
                    <tr>
                        <td><fmt:message key="OPERATION" />:</td><td><fmt:message key="GET_DEVICE_DETAILS_PROCESSOR" /></td>
                    </tr>

                </table>
            </td>
        </tr>


        <c:if test="${state == 'P'}">
        </c:if>

        <tr><td><hr/></td></tr>
        <tr>
            <td align="center">
                <table cellpadding="10" cellspacing="0" border="0">
                    <tr>
                        <td><input type="button" name="back" value="<fmt:message key="CANCEL" />" onclick="goBack()" /></td>
                    </tr>
                </table>
            </td>
        </tr>

        <tr>
            <td align="center">
                <table>
                    <tr>
                        <td><fmt:message key="OPERATIONS_LIST" /></td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td align="center">
                <table cellpadding="5" cellspacing="0" border="1">
                    <tr>
                        <th><fmt:message key="OPERATION" /></th>
                        <th><fmt:message key="NODE_URI" /></th>
                        <c:choose>
                            <c:when test="${state == 'P'}">
                            </c:when>
                            <c:otherwise>
                                <th><fmt:message key="RESULTS" /></th>
                                <th><fmt:message key="STATUS_CODE" /></th>
                            </c:otherwise>
                        </c:choose>
                    </tr>
                    <%
                        ManagementOperation operation = null;
                        ManagementOperationResult operationResult = null;
                        String command = null;

                        String value = null;
                        int numNodes = 0;
                        java.util.Map nodes = null;
                        java.util.Iterator itNodes = null;

                        List operationsList        = dmDemoBean.genericProcessorTools.getOperationsList();
                        List operationsResultsList = null;
                        int numOfOperations        = operationsList.size();

                        if (dmDemoBean.getSessionState().equals("C") ) {
                            operationsResultsList = dmDemoBean.genericProcessorTools.getOperationsResultsWithValue();
                        }

                        //
                        // The last operation isn't showed beacause is the dummy alert
                        //
                        for (int i=0; i< (numOfOperations - 1); i++) {
                            operation = (ManagementOperation)operationsList.get(i);
                            if (!(operation instanceof TreeManagementOperation)) {
                              continue;
                            }
                            if ( dmDemoBean.getSessionState().equals("C") ) {
                                operationResult = (ManagementOperationResult)operationsResultsList.get(i);
                                nodes = operationResult.getNodes();
                                command = operationResult.getCommand();
                            } else {
                                nodes = ((TreeManagementOperation)operation).getNodes();
                                command = operation.getDescription();
                            }
                            numNodes = nodes.size();
                            value    = null;

                            itNodes  = nodes.keySet().iterator();
                        %>
                            <tr>
                                <td><%= command %></td>
                                <td>
                                    <!-- Nodes URI-->
                                    <table>
                                        <%
                                            while (itNodes.hasNext()) {
                                        %>
                                            <tr>
                                                <td><%= itNodes.next() %></td>
                                            </tr>
                                        <%
                                        }
                                        %>
                                    </table>
                                </td>

                                    <c:if test="${state == 'P'}">
                                    </c:if>
                                    <c:if test="${state == 'C'}">
                                        <%
                                            int statusCode = operationResult.getStatusCode();
                                        %>
                                        <td>
                                            <%
                                                if (command.equals("Get")) {
                                            %>
                                                    <table>
                                                        <%
                                                            itNodes  = nodes.keySet().iterator();
                                                            Object result = null;
                                                            while (itNodes.hasNext()) {
                                                                result = nodes.get(itNodes.next());
                                                                if (result instanceof TreeNode) {
                                                                    result = ((TreeNode)result).getValue();
                                                                }
                                                        %>
                                                                <tr>
                                                                    <td><%= result %></td>
                                                                </tr>

                                                        <%
                                                            }
                                                        %>
                                                    </table>
                                           <%
                                                }  else {
                                           %>
                                                     &nbsp;
                                           <%
                                                }
                                            %>
                                        </td>
                                        <td align="center"><%= statusCode%></td>
                                    </c:if>
                            </tr>
                    <%
                        }
                    %>

                </table>
            </td>
        </tr>
        <c:if test="${state == 'P'}">
            <tr>
                <td align="center">
                    <table>
                        <tr>

                        </tr>
                    </table>
                </td>
            </tr>
        </c:if>
        <tr><td><br/><br/></td></tr>
    </table>
    </form>

</body>
</html>
