--
-- This script contains the ddl to create the engine database.
--
-- @author Stefano Fornari @ Funambol
--
-- @version $Id: create_engine.ddl,v 1.1 2005/05/16 17:32:58 nichele Exp $
--

create table sync4j_principal
(
  username    varchar(32) not null,
  device      varchar(128) not null,
  id          varchar(128) not null,

  constraint pk_sync4j_principal primary key (id)
);



create table sync4j_user
(
  username   varchar(32) not null,
  password   varchar(32),
  email      varchar(50),
  first_name varchar(255),
  last_name  varchar(255),
  internal_user char(1 ) default 'N',

  constraint pk_sync4j_user primary key (username)
);



create table sync4j_device
(
  id              varchar(128) not null,
  description     varchar(255),
  type            varchar(255),
  digest          varchar(255),
  client_nonce    varchar(255),
  server_nonce    varchar(255),
  server_password varchar(255),

  constraint pk_sync4j_device primary key (id)
);



create table sync4j_id
(
  idspace varchar(30) not null,
  counter int         not null,

  constraint pk_sync4j_id primary key (idspace)
);



create table sync4j_role
(
  role        varchar(128) not null,
  description varchar(200) not null,

  constraint pk_sync4j_role primary key (role)
);


create table sync4j_user_role
(
  username varchar(32 ) not null,
  role     varchar(128) not null,

  constraint pk_sync4j_user_role primary key (username,role)
);

create table sync4j_dm_state
(
    id        varchar(32)          ,
    device    varchar(128)         ,
    mssid     varchar(32)          ,
    state     char(1)              ,
    start_ts  datetime             ,
    end_ts    datetime             ,
    operation varchar(255)         ,
    info      varchar(1024)        ,
);

create index nxd_dm_state on sync4j_dm_state (device   );
create index nxd_dm_state on sync4j_dm_state (mssid    );
create index nxd_dm_state on sync4j_dm_state (state    );
create index nxd_dm_state on sync4j_dm_state (operation);
create index nxd_dm_state on sync4j_dm_state (info     );


--
-- CONSTRAINTS
--


alter table sync4j_principal add constraint fk_user foreign key (
  username
)
references sync4j_user (
  username
);


alter table sync4j_principal add constraint fk_device foreign key (
  device
)
references sync4j_device (
  id
);


alter table sync4j_dm_state add constraint fk_device1 foreign key (
  device
)
references sync4j_device (
  id
);
